// MeterBarCode.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Meterbar.h"
#include "MeterBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMeterBar

CMeterBar::CMeterBar()
{
	m_dProgress = 0.0;
}

CMeterBar::~CMeterBar()
{
}


BEGIN_MESSAGE_MAP(CMeterBar, CStatusBar)
	//{{AFX_MSG_MAP(CMeterBar)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMeterBar message handlers

void CMeterBar::SetProgressBar(double dProgress)
{
	m_dProgress = dProgress;
	DrawBar();
}

void CMeterBar::DrawBar()
{
	int index = CommandToIndex(ID_INDICATOR_METER);
	if(index >= 0)
	{
		CDC* pDC = GetDC();
		RECT rcPane;
		GetItemRect(index, &rcPane);
		int width = rcPane.right - rcPane.left - 2;
		int right = rcPane.right;
		width = (int)(m_dProgress * (double) width);
		rcPane.left += 1; rcPane.right = rcPane.left + width;
		rcPane.top += 1; rcPane.bottom -= 1;
		CBrush brush1, brush2;
		if(brush1.CreateSysColorBrush(COLOR_BTNSHADOW))
			pDC->FillRect(&rcPane, &brush1);
		rcPane.left = rcPane.right;
		rcPane.right = right - 1;
		if(brush2.CreateSysColorBrush(COLOR_BTNFACE))
			pDC->FillRect(&rcPane, &brush2);

		ReleaseDC(pDC);
	}
}

void CMeterBar::OnPaint() 
{
	CStatusBar::OnPaint();	// not supposed to call this!
	DrawBar();
}

BOOL CMeterBar::SetIndicators(const UINT *lpIDArray, int nIDCount)
{
	BOOL bRetval = CStatusBar::SetIndicators(lpIDArray, nIDCount);
	int index = CommandToIndex(ID_INDICATOR_METER);
	if(bRetval && index >= 0)
	{
		SetPaneText(index, "", false);
	}
	return bRetval;
}
